package ssw.mj;

import java.io.BufferedOutputStream;
import java.io.FileOutputStream;
import java.io.FileReader;
import java.io.IOException;

import ssw.mj.codegen.Code;
 
/**
 * <code>Compiler</code> is the driver for the MicroJava-Compiler.
 * 
 * Execute<br>
 * <code>java ssw.mj.Compiler &lt;<i>MJ-Source-Filename</i>&gt;<br>
 * to start compililation.
 * 
 * @author AW
 * @version 2.1 2002-09-02
 */
public class Compiler {

	private static String objFileName(String s) {
		int i = s.lastIndexOf('.');
		if (i < 0) return s + ".obj";
		else return s.substring(0, i) + ".obj";
	}
	
	public static void main(String[] args) {
		// --- get the filename
		if (args.length < 1) { 
			System.out.println("usage: java Compiler filename.mic"); 
			return;
		}
		String filename = args[0];
		String output = objFileName(filename);
		
		try {
			System.out.println("-----------------------------------");
			Scanner.init(new FileReader(filename));
			System.out.println("Parsing file " + filename + "\n");
			Parser.parse();
			int errCnt = Parser.Errors.count();
			switch (errCnt) {
				case 0:	
					System.out.println("OK, no errors!"); 
					System.out.println("Generating object file ...");
					Code.write(new BufferedOutputStream(new FileOutputStream(output)));
					System.out.println("Done.");
					break;
				case 1: System.out.println("\n1 error"); break;
				default: System.out.println("\n" + errCnt + " errors"); break;
			}
		} catch (IOException ioe) {
		  System.out.println("File " + filename + " not found.");
		}		
	}
}
