package ssw.mj;

import java.io.BufferedReader;
import java.io.IOException;
import java.io.PrintWriter;
import java.io.Reader;

/**
 * The Scanner for the MicroJava Compiler.
 */
public class Scanner {
	private static final char EOF = '\u0080';
	private static final char CR = '\r';
	private static final char LF = '\n';

	private static final int
		none       = Token.none,
		ident      = Token.ident,
		number     = Token.number,
		charConst  = Token.charConst,
		plus       = Token.plus,
		minus      = Token.minus,
		times      = Token.times,
		slash      = Token.slash,
		rem        = Token.rem,
		eql        = Token.eql,
		neq        = Token.neq,
		gtr        = Token.gtr,
		geq        = Token.geq,
		less       = Token.less,
		leq        = Token.leq,
		and        = Token.and,
		or         = Token.or,
		assign     = Token.assign,
		pplus      = Token.pplus,
		mminus     = Token.mminus,
		semicolon  = Token.semicolon,
		comma      = Token.comma,
		period     = Token.period,
		lpar       = Token.lpar,
		rpar       = Token.rpar,
		lbrack     = Token.lbrack,
		rbrack     = Token.rbrack,
		lbrace     = Token.lbrace,
		rbrace     = Token.rbrace,
		classKW    = Token.classKW,
		continueKW = Token.continueKW,
		doKW       = Token.doKW,
		elseKW     = Token.elseKW,
		finalKW    = Token.finalKW,
		ifKW       = Token.ifKW,
		newKW      = Token.newKW,
		printKW    = Token.printKW,
		readKW     = Token.readKW,
		returnKW   = Token.returnKW,
		voidKW     = Token.voidKW,
		whileKW    = Token.whileKW,
		eof        = Token.eof;

	private static Reader in;
	private static PrintWriter out;

	/** Lookahead character. (= next (unhandled) char in the input stream) */
	private static char ch;

	/** Current line in input stream. */
	private static int line;

	/** Current column in input stream. */
	private static int col;

	/** Initializes the scanner. */
	public static void init (Reader r) {
		init(r, null);
	}

	public static void init (Reader r, PrintWriter w) {
		in = new BufferedReader(r);
		out = w;

		/*----- put additional initialization code here -----*/
	}

	/** Reads next char from input stream into ch.
	 *  Keeps pos, line and col in sync with reading position.
	 */
	private static void nextCh () {

	}

	public static Token next () {
		return null;	/*----- replace with your own code -----*/
	}

	private static void error (String message) {
		// leave this here for scanner testing
		if (out != null) 
			out.println("-- line " + line + ", col " + col + ": " + message);
		Parser.Errors.synError(message);
	}

	private static void readName (Token t) {

	}

	private static void readNumber (Token t) {

	}

	/** Skip nested multi-line comments. */
	private static void skipComment () {

	}

} // end Scanner
